codeforces 977F Consecutive Subsequence

题目

You are given an integer array of length n .

You have to choose some subsequence of this array of maximum length such that this subsequence forms a increasing sequence of consecutive integers. In other words the required sequence should be equal to [x,x+1,,x+k1] for some value x and length k .

Subsequence of an array can be obtained by erasing some (possibly zero) elements from the array. You can erase any elements, not necessarily going successively. The remaining elements preserve their order. For example, for the array [5,3,1,2,4] the following arrays are subsequences: [3] , [5,3,1,2,4] , [5,1,4] , but the array [1,3] is not.

Input
The first line of the input containing integer number n (1n2105) — the length of the array. The second line of the input containing n integer numbers a1,a2,,an ( 1ai109 ) — the array itself.

Output
On the first line print k — the maximum length of the subsequence of the given array that forms an increasing sequence of consecutive integers.

On the second line print the sequence of the indices of the any maximum length subsequence of the given array that forms an increasing sequence of consecutive integers.

Examples

Input
7
3 3 4 7 5 6 8
Output
4
2 3 5 6

Input
6
1 3 5 2 4 6
Output
2
1 4

Input
4
10 9 8 7
Output
1
1

Input
9
6 7 8 3 4 5 9 10 11
Output
6
1 2 3 7 8 9

Note

All valid answers for the first example (as sequences of indices):

  • [1,3,5,6]
  • [2,3,5,6]

All valid answers for the second example:

  • [1,4]
  • [2,5]
  • [3,6]

All valid answers for the third example:

  • [1]
  • [2]
  • [3]
  • [4]

All valid answers for the fourth example:

  • [1,2,3,7,8,9]

分析

【题意】
给一个n个数的序列,找出最长的只含有连续的数的子序列。

【分析】

  1. 对于每个 x ,必须知道x+1的位置,如果把输入按大小排序,就能很快的找到 x+1 的位置。
  2. 不能对每个 x 都处理到没有下一个数,所以应该先处理后面的数,并记录
    • 以该数为起点的最长序列的长度。
    • 上述序列的下个数的位置

【思路】
以倒序的方式处理数据,对位置i,它的值 val[i] ,就寻找 val[j]=val[i]+1 的位置 j ,用j的记录来更新i的记录,用 dp 的转移方程来说的话就是, dp[i]=max{dp[min{x}]+1} , (x>i && val[x]==val[i])
处理结束后,所有的点的记录都是最优的,所以可以维护一个位置 f ,在处理每一个点以后,将f对应的长度与这个点的长度比较,如果更大就把f更新为这个点

代码

#include<stdio.h>
#include<algorithm>
using std::sort;
#define N_max 200005
#define max(a, b) ((a)>(b)?(a):(b))
struct thing{ int v; int po; }arr[N_max];
int ipt[N_max];
int next[N_max];
int dp[N_max];
int cmpv(thing t1, thing t2) { if (t1.v == t2.v)return t1.po <= t2.po; return t1.v < t2.v; }
#define inp(t) (arr[t].po)
int p[2];
int n;
int bins(int k) {
    int l = 0,r=n+1,m;
    while (l+1<r)
    {
        m = (l + r) / 2;
        if (arr[m].v < k)l = m;
        else r = m;
    }
    return r;
}
int main() {

    scanf("%d", &n);
    for (int i = 1; i <= n; ++i)
    {
        scanf("%d", ipt + i);
        arr[i].v = ipt[i];
        arr[i].po = i;
    }
    //arr只用来检索
    sort(arr + 1, arr + n + 1, cmpv);
    int ma=0, fr;


    for (int i = n; i >= 1; --i) {
        next[i] = i;
        dp[i] = 1;
        //在arr中检索最近的ipt[i]+1
        for (int t = bins(ipt[i] + 1); arr[t].v == ipt[i] + 1 && t <= n; ++t) {
            if (arr[t].po < i)continue;
            //更新dp[i]和next[i]
            if (dp[arr[t].po] + 1 > dp[i]) {
                dp[i] = dp[arr[t].po] + 1;
                next[i] = arr[t].po;
                break;
            }
        }

        if (ma < dp[i]) {
            ma = dp[i];
            fr = i;
        }

    }
    printf("%d\n", ma);
    for (int t = fr;; t = next[t]) {
        printf("%d ", t);
        if (t == next[t])break;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值